#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
long fibonacci (int);

int main(int argc,char** argv)
{
  int n;
  float  time;
  struct timeval t1, t2;
  if (argc==1){
	printf("Enter a natural number: ");
	if (scanf("%d", &n) != 1) {
		printf("Input error.\n");
		return 1;
	}
  }else if (argc > 2){
	printf("Usage : %s <N>\n",argv[0]);
	return 1;
  }else{
	n = (int)atoi(argv[1]);
  }
  if (n<0) {
    printf("Fibonacci is undefined for negative integers.\n");
    return -1;
  }
  else {
    gettimeofday(&t1, NULL);
    printf("fib(%d)=%ld\n", n, fibonacci(n));
    gettimeofday(&t2, NULL);
    time = (t2.tv_sec - t1.tv_sec) + ((float)(t2.tv_usec - t1.tv_usec))/1000000;
    printf("time = %f s\n",time);
  }
  return 0;
}

long fibonacci(int n)
{
  if (1 == n || 2 == n) {
    return 1;
  } else {
    return (fibonacci(n-1) + fibonacci(n-2));
  }
}

