#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <assert.h>
#include <pthread.h>
#include <sched.h> 
#include <string.h>

//FILE *output_file;
void *reader_func(void *arg)
{
  char *pts_name = (char *) arg;
  FILE *pts_file;
  //  char line[255];

  pts_file = fopen(pts_name,"r");
  fprintf(stderr,"pts %s dévié.\n",pts_name);    
  while (1) {
    char read = fgetc(pts_file);
    if (read == 'x') {
      fprintf(stderr,"fini sur %s\n",pts_name);
      break;
    }
    if (((int) read) == 13)
      fprintf(stderr,"\n");
    fprintf(stderr,"%c",read);
  }
  fclose(pts_file);
  return NULL;
}

int main(int argc,char ** argv)
{ 
  int i;
  void *status;
  pthread_t reader1_tid, reader2_tid;
  pthread_attr_t attributes;
  char * pts_1, *pts_2;
  
  if (argc!=3){
	printf("Usage   : %s <pts_1> <pts_2>\n",argv[0]);
	printf("Example : %s /dev/pts/5 /dev/pts/6\n",argv[0]);
	return 1;
  }
  pts_1= argv[1];
  pts_2= argv[2];
  /* Pour l'instant, nous conservons les valeurs par défaut
     en ce qui concerne les attributs des processus... */
  i = pthread_attr_init(&attributes);
  assert(i == 0);
  
  /* Création des processus légers */
  i = pthread_create(&reader1_tid, &attributes, reader_func, pts_1);
  assert(i == 0);

  i = pthread_create(&reader2_tid, &attributes, reader_func, pts_2);
  assert(i == 0);
 

  
  /* Récupération de leur terminaison */
  i= pthread_join(reader1_tid, &status);
  assert(i == 0);
  i= pthread_join(reader2_tid, &status);
  assert(i == 0);
  //  fclose(output_file);  
  return 0;
}




